Overview | Package | Class | Tree | Deprecated | Index | Help
| Servlet 3.0 - Apache Tomcat 7.0.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.servlet
Interface RequestDispatcher

    public interface RequestDispatcher

Defines an object that receives requests from the client and sends them to any resource (such as a servlet, HTML file, or JSP file) on the server. The servlet container creates the `RequestDispatcher` object, which is used as a wrapper around a server resource located at a particular path or given by a particular name.

This interface is intended to wrap servlets, but a servlet container can create `RequestDispatcher` objects to wrap any type of resource.

Version:
  $Version$
Author:
  Various
See Also:
  `ServletContext.getRequestDispatcher(java.lang.String)`, `ServletContext.getNamedDispatcher(java.lang.String)`, `ServletRequest.getRequestDispatcher(java.lang.String)`

Field Summary
`static java.lang.String` | `ERROR_EXCEPTION`
`static java.lang.String` | `ERROR_EXCEPTION_TYPE`
`static java.lang.String` | `ERROR_MESSAGE`
`static java.lang.String` | `ERROR_REQUEST_URI`
`static java.lang.String` | `ERROR_SERVLET_NAME`
`static java.lang.String` | `ERROR_STATUS_CODE`
`static java.lang.String` | `FORWARD_CONTEXT_PATH`
`static java.lang.String` | `FORWARD_PATH_INFO`
`static java.lang.String` | `FORWARD_QUERY_STRING`
`static java.lang.String` | `FORWARD_REQUEST_URI`
`static java.lang.String` | `FORWARD_SERVLET_PATH`
`static java.lang.String` | `INCLUDE_CONTEXT_PATH`
`static java.lang.String` | `INCLUDE_PATH_INFO`
`static java.lang.String` | `INCLUDE_QUERY_STRING`
`static java.lang.String` | `INCLUDE_REQUEST_URI`
`static java.lang.String` | `INCLUDE_SERVLET_PATH`

Method Summary
`void` | `forward(ServletRequest request, ServletResponse response)` Forwards a request from a servlet to another resource (servlet, JSP file, or HTML file) on the server.
`void` | `include(ServletRequest request, ServletResponse response)` Includes the content of a resource (servlet, JSP page, HTML file) in the response.

Field Detail

### ERROR_EXCEPTION

    static final java.lang.String ERROR_EXCEPTION

See Also:
  Constant Field Values

### ERROR_EXCEPTION_TYPE

    static final java.lang.String ERROR_EXCEPTION_TYPE

See Also:
  Constant Field Values

### ERROR_MESSAGE

    static final java.lang.String ERROR_MESSAGE

See Also:
  Constant Field Values

### ERROR_REQUEST_URI

    static final java.lang.String ERROR_REQUEST_URI

See Also:
  Constant Field Values

### ERROR_SERVLET_NAME

    static final java.lang.String ERROR_SERVLET_NAME

See Also:
  Constant Field Values

### ERROR_STATUS_CODE

    static final java.lang.String ERROR_STATUS_CODE

See Also:
  Constant Field Values

### FORWARD_CONTEXT_PATH

    static final java.lang.String FORWARD_CONTEXT_PATH

See Also:
  Constant Field Values

### FORWARD_PATH_INFO

    static final java.lang.String FORWARD_PATH_INFO

See Also:
  Constant Field Values

### FORWARD_QUERY_STRING

    static final java.lang.String FORWARD_QUERY_STRING

See Also:
  Constant Field Values

### FORWARD_REQUEST_URI

    static final java.lang.String FORWARD_REQUEST_URI

See Also:
  Constant Field Values

### FORWARD_SERVLET_PATH

    static final java.lang.String FORWARD_SERVLET_PATH

See Also:
  Constant Field Values

### INCLUDE_CONTEXT_PATH

    static final java.lang.String INCLUDE_CONTEXT_PATH

See Also:
  Constant Field Values

### INCLUDE_PATH_INFO

    static final java.lang.String INCLUDE_PATH_INFO

See Also:
  Constant Field Values

### INCLUDE_QUERY_STRING

    static final java.lang.String INCLUDE_QUERY_STRING

See Also:
  Constant Field Values

### INCLUDE_REQUEST_URI

    static final java.lang.String INCLUDE_REQUEST_URI

See Also:
  Constant Field Values

### INCLUDE_SERVLET_PATH

    static final java.lang.String INCLUDE_SERVLET_PATH

See Also:
  Constant Field Values

Method Detail

### forward

    void forward(ServletRequest request,
                 ServletResponse response)
                 throws ServletException,
                        java.io.IOException

  Forwards a request from a servlet to another resource (servlet, JSP file, or HTML file) on the server. This method allows one servlet to do preliminary processing of a request and another resource to generate the response.

  For a `RequestDispatcher` obtained via `getRequestDispatcher()`, the `ServletRequest` object has its path elements and parameters adjusted to match the path of the target resource.

  `forward` should be called before the response has been committed to the client (before response body output has been flushed). If the response already has been committed, this method throws an `IllegalStateException`. Uncommitted output in the response buffer is automatically cleared before the forward.

  The request and response parameters must be either the same objects as were passed to the calling servlet's service method or be subclasses of the `ServletRequestWrapper` or `ServletResponseWrapper` classes that wrap them.

  Parameters:
    `request` - a `ServletRequest` object that represents the request the client makes of the servlet
    `response` - a `ServletResponse` object that represents the response the servlet returns to the client
  Throws:
    `ServletException` - if the target resource throws this exception
    `java.io.IOException` - if the target resource throws this exception
    `java.lang.IllegalStateException` - if the response was already committed

### include

    void include(ServletRequest request,
                 ServletResponse response)
                 throws ServletException,
                        java.io.IOException

  Includes the content of a resource (servlet, JSP page, HTML file) in the response. In essence, this method enables programmatic server-side includes.

  The `ServletResponse` object has its path elements and parameters remain unchanged from the caller's. The included servlet cannot change the response status code or set headers; any attempt to make a change is ignored.

  The request and response parameters must be either the same objects as were passed to the calling servlet's service method or be subclasses of the `ServletRequestWrapper` or `ServletResponseWrapper` classes that wrap them.

  Parameters:
    `request` - a `ServletRequest` object that contains the client's request
    `response` - a `ServletResponse` object that contains the servlet's response
  Throws:
    `ServletException` - if the included resource throws this exception
    `java.io.IOException` - if the included resource throws this exception

Overview | Package | Class | Tree | Deprecated | Index | Help
| Servlet 3.0 - Apache Tomcat 7.0.29
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000-2012 Apache Software Foundation. All Rights Reserved.